# sgem

`sgem` is a simple, minimalistic way to build and publish
[gems](http://rubygems.org) using [rake](http://rake.rubyforge.org).

`sgem` is based on the excellent [mg](https://github.com/sr/mg) (written by
[Ryan Tomayko](http://tomayko.com), extracted by
[Simon Rozet](http://atonie.org)).

## Usage

In your Rakefile:

```ruby
require 'sgem/auto'
```

The following tasks are now available:

```sh
rake archive      # build archive into pkg/
rake gem          # build gem into pkg/
rake gem:install  # build and install as local gem
rake gem:publish  # push the gem to rubygems.org
rake package      # build gem and archive into pkg/
```

If you do not trust `sgem` to automatically determine your gemspec, you may
provide it manually:

```ruby
require 'sgem'

sgem 'project.gemspec'
```

You may customize the output directory and archive format (as supported by
`git-archive`) through either Ruby:

```ruby
require 'sgem/auto'

SGem.package_dir    = 'dist'
SGem.archive_format = '.zip'
```

...or environment variables:

```sh
$ DEST=dist ARCHIVE=.zip rake package
```

## License

`sgem` is free and unencumbered software released into the public domain.
